## ncc 2.7

=== Makefile ===

# these are set by config
CC = g++
DESTDIR ?= /usr
LCFLAGS = -g -O2
BINDIR = ${DESTDIR}/bin
MANDIR = ${DESTDIR}/share/man
INCLUDEDIR = ${DESTDIR}/include
NOGNU = /usr/include/nognu

#

CFLAGS = $(LCFLAGS) -c


tout: objdir/ncc nccnav/nccnav
	@echo Salut.

install: tout
	cp objdir/ncc $(BINDIR)/ncc
	ln -sf $(BINDIR)/ncc $(BINDIR)/nccar
	ln -sf $(BINDIR)/ncc $(BINDIR)/nccld
	ln -sf $(BINDIR)/ncc $(BINDIR)/nccc++
	ln -sf $(BINDIR)/ncc $(BINDIR)/nccg++
	cp nccnav/nccnav $(BINDIR)/nccnav
	ln -fs $(BINDIR)/nccnav $(BINDIR)/nccnavi
	cp ncc.1 $(MANDIR)/man1
	cp nccnav/nccnav.1 $(MANDIR)/man1
	cp doc/nognu $(INCLUDEDIR)

uninstall:
	rm -f $(BINDIR)/ncc $(BINDIR)/nccnav $(BINDIR)/nccnavi $(MANDIR)/man1/ncc.1 $(INCLUDEDIR)/nognu
	rm -f $(BINDIR)/nccar $(BINDIR)/nccld $(BINDIR)/nccc++ $(BINDIR)/nccg++

nccnav/nccnav: nccnav/nccnav.C
	@echo Compiling nccnav viewer.
	@cd nccnav && make

objdir/ncc: objdir/dbstree.o objdir/inttree.o objdir/lex.o objdir/space.o objdir/cexpand.o objdir/cdb.o objdir/parser.o objdir/ccexpr.o objdir/preproc.o objdir/usage.o main.C
	$(CC) $(LCFLAGS) main.C objdir/*.o -o objdir/ncc 

objdir/cexpand.o: cexpand.C
	$(CC) $(CFLAGS) cexpand.C
	@mv cexpand.o objdir/

objdir/parser.o: parser.C
	$(CC) $(CFLAGS) parser.C
	@mv parser.o objdir/

objdir/inttree.o: inttree.[Ch]
	$(CC) $(CFLAGS) inttree.C
	@mv inttree.o objdir/

objdir/dbstree.o: dbstree.[Ch]
	$(CC) $(CFLAGS) dbstree.C
	@mv dbstree.o objdir/

objdir/lex.o: lex.C
	$(CC) $(CFLAGS) lex.C
	@mv lex.o objdir/

objdir/cdb.o: cdb.C
	$(CC) $(CFLAGS) cdb.C
	@mv cdb.o objdir/

objdir/space.o: space.C
	$(CC) $(CFLAGS) space.C
	@mv space.o objdir/

objdir/usage.o: usage.C
	$(CC) $(CFLAGS) usage.C
	@mv usage.o objdir/

objdir/ccexpr.o: ccexpr.C
	$(CC) $(CFLAGS) ccexpr.C
	@mv ccexpr.o objdir/

objdir/preproc.o: preproc.C
	$(CC) $(CFLAGS) preproc.C
	@mv preproc.o objdir/

wc:
	wc *.[Ch] nccnav/*.C | sort -n

clean:
	rm -f objdir/*.o

distclean:
	rm -f objdir/* objdir/ncc
	@cd nccnav && make clean

## ncc 2.8

=== nccnav/Makefile ===

CC = g++
LCFLAGS = -Wall -g
CFLAGS = $(LCFLAGS) -c -g

OBJDIR = ../objdir

$(OBJDIR)/nccnav: nccnav.C $(OBJDIR)/dbstree.o $(OBJDIR)/inttree.o
	$(CC) -g nccnav.C -I.. -lncurses -o nccnav $(OBJDIR)/dbstree.o $(OBJDIR)/inttree.o

$(OBJDIR)/dbstree.o: ../dbstree.[Ch]
	$(CC) $(CFLAGS) ../dbstree.C -c
	@mv dbstree.o $(OBJDIR)

$(OBJDIR)/inttree.o: ../inttree.[Ch]
	$(CC) $(CFLAGS) ../inttree.C -c
	@mv inttree.o $(OBJDIR)

clean:
	rm -f *.o nccnav

=== debian/changelog ===
ncc (2.8-6build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:51:21 +0100

ncc (2.8-6) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make and pass a
    C++ compiler via CC. (Closes: #943464)

 -- Anuradha Weeraman <aweeraman@gmail.com>  Fri, 25 Oct 2019 08:15:48 -0400

ncc (2.8-5) unstable; urgency=medium

  * Bumped up standards version, compat
  * Updated patches and python scripts
  * Fixed issue with binaries and scripts not getting installed properly
  * Lintian fixes

 -- Anuradha Weeraman <aweeraman@gmail.com>  Tue, 22 Oct 2019 17:53:45 -0400

ncc (2.8-4) unstable; urgency=low

  * Converted source format to 3.0 (quilt)
  * Fixed lintian warnings

 -- Anuradha Weeraman <aweeraman@gmail.com>  Fri, 04 Oct 2019 14:45:00 -0500

ncc (2.8-3) unstable; urgency=low

  * Changed dependency to use libncurses-dev
  * Upgraded Standards-Version to 4.4.0
  * Fixed missing debian/source/format warning
  * Upgraded debian/compat to 9

 -- Anuradha Weeraman <aweeraman@gmail.com>  Tue, 01 Oct 2019 05:38:00 -0500

ncc (2.8-2.1) UNRELEASED; urgency=medium

  * Non-maintainer upload.
  * Fixed type for file_chunk::start,end from unsigned int to int
    to fix narrowing conversion issues with gcc-6 (Closes: #811745)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 07 Jan 2017 22:10:15 +0100

ncc (2.8-2) unstable; urgency=low

  * Added gengraph to /usr/bin and associated man page
  * Updates to man pages
  * Fixed lintian warnings
  * Removed scripts from /usr/share/doc/ncc

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 01 Nov 2014 01:09:18 +0530

ncc (2.8-1) unstable; urgency=low

  * New upstream release.
  * debian/control (Depends): Added python and ${misc:Depends}.
    (Standards-Version): Conforms to 3.8.4.

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 08 Feb 2010 11:25:55 +0900

ncc (2.7-3) unstable; urgency=low

  * Lintian cleanups
  * Changed maintainer uid
  * Added DM-Upload-Allowed to debian/control

 -- Anuradha Weeraman <anuradha@gnuromancer.org>  Thu, 22 May 2008 00:33:05 -0400

ncc (2.7-2) unstable; urgency=medium

  * Upgraded to Standard-Version 3.7.3
  * Renamed /usr/bin/ncc to /usr/bin/nccgen (Closes: #407405)
  * Urgency medium because this fixes RC bug
  * Removed "Conflict: nemerle" from debian/control
  * Added README.Debian

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 15 Dec 2007 23:18:18 -0500

ncc (2.7-1) unstable; urgency=low

  * New upstream release
  * Added -Wno-write-strings to compiler flags
  * Moved gengraph.py to /usr/share/doc/scripts (Closes: #411134)
  * Removed dependency on Python
  * Fixed lintian warning

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 01 Dec 2007 14:50:09 -0500

ncc (2.6-5) unstable; urgency=low

  * Added gengraph.py and man page to /usr/bin (Closes: #411134)

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Wed, 30 May 2007 23:49:52 -0400

ncc (2.6-4) unstable; urgency=low

  * Conflicts with nemerle. Updated control file (Closes: #407405)
  * Typo in Uploader field

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Fri, 19 Jan 2007 20:38:29 -0500

ncc (2.6-3) unstable; urgency=low

  * Updated changelog (Closes: #387415)

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 30 Dec 2006 15:27:24 -0500

ncc (2.6-2) unstable; urgency=low

  * Updated debian/control

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 30 Dec 2006 15:19:03 -0500

ncc (2.6-1) unstable; urgency=low

  * New upstream release.
  * Updated debhelper compatibility level
  * Added NIIEBE Yutaka as the uploader
  * Added NCC homepage to debian/control
  * Updated Standards-version to 3.7.2
  * Added debian/watch file
  * Updated Build-depends

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Sat, 30 Dec 2006 13:03:46 -0500

ncc (2.5-2) unstable; urgency=low

  * Fixed debian/control.

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Tue, 26 Dec 2006 14:56:44 -0500

ncc (2.5-1) unstable; urgency=low

  * Initial release.

 -- Anuradha Weeraman (anu) <aweeraman@gmail.com>  Fri, 22 Dec 2006 14:47:14 -0500

=== debian/control ===
Source: ncc
Section: devel
Priority: optional
Maintainer: Anuradha Weeraman <aweeraman@gmail.com>
Build-Depends: debhelper (>=12~), libncurses-dev, debhelper-compat (=12)
Standards-Version: 4.4.1
Uploaders: NIIBE Yutaka <gniibe@fsij.org>
Vcs-Browser: https://salsa.debian.org/debian/ncc
Vcs-Git: https://salsa.debian.org/debian/ncc.git
Homepage: http://students.ceid.upatras.gr/~sxanth/ncc/
Rules-Requires-Root: no

Package: ncc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python2
Description: C source code analyzer
 A small, extensible tool that provides program analysis data of C
 source code. This data can be used to analyze the function call flow
 of programs with tools such as graphviz and springgraph. Included
 with this distribution is nccnav that can be used to study the call
 hierarchy of C source code on a text-mode console.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp: configure-stamp
	dh_testdir
	[ -e objdir ] || mkdir objdir
	dh_auto_build -- 'CC=$$(CXX)'
	touch build-stamp

clean:
	dh_prep
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -f debian/ncc.substvars
	rm -f debian/files
	rm -f scripts/gengraph scripts/gengraph.1
	rm -f nccgen.1
	rm -f docs/ncc.h
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean

install: build
	dh_prep
	dh_testdir
	dh_testroot
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/ncc/usr
	dh_clean


binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	cp scripts/gengraph.py scripts/gengraph
	cp scripts/gengraph.py.1 scripts/gengraph.1
	cp doc/nognu doc/ncc.h
	dh_install
	rm -f doc/ncc.h
	dh_installchangelogs -k doc/CHANGES
	dh_installdocs -Xdoc/LICENSE -Xdoc/nognu -Xdoc/dbstree.aux \
                       -Xdoc/dbstree.dvi -Xdoc/dbstree.log -Xdoc/farg.c \
                       -Xdoc/fptr.c README.1.8.rw doc/*
	dh_installexamples doc/fptr.c doc/farg.c
	cp ncc.1 nccgen.1
	dh_installman
	dh_link usr/bin/nccgen usr/bin/nccar
	dh_link usr/bin/nccgen usr/bin/nccld
	dh_link usr/bin/nccgen usr/bin/nccc++
	dh_link usr/bin/nccgen usr/bin/nccg++
	dh_link usr/bin/nccnav usr/bin/nccnavi
	dh_link usr/share/man/man1/nccgen.1.gz usr/share/man/man1/nccar.1.gz
	dh_link usr/share/man/man1/nccgen.1.gz usr/share/man/man1/nccld.1.gz
	dh_link usr/share/man/man1/nccgen.1.gz usr/share/man/man1/nccc++.1.gz
	dh_link usr/share/man/man1/nccgen.1.gz usr/share/man/man1/nccg++.1.gz
	dh_link usr/share/man/man1/nccnav.1.gz usr/share/man/man1/nccnavi.1.gz
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=2
http://students.ceid.upatras.gr/~sxanth/ncc/ncc-(.*)\.tar\.gz
